/*************************************************************************
 *
 *  $RCSfile: cc50_solaris_sparc.hxx,v $
 *
 *  $Revision: 1.1.1.1.110.2 $
 *
 *  last change: $Author: vg $ $Date: 2005/07/01 14:41:26 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <cstddef>

#ifndef _RTL_STRING_HXX_
#include <rtl/string.hxx>
#endif
#include <typeinfo>

typedef struct _uno_Any uno_Any;
typedef struct _uno_Mapping uno_Mapping;

// private C50 structures and functions
namespace __Crun
{
	struct static_type_info
	{
        std::ptrdiff_t m_pClassName;
		int			m_nSkip1; // must be 0
		void*		m_pMagic; // points to some magic data
		int			m_nMagic[ 4 ];
		int			m_nSkip2[2]; // must be 0
	};
	void* ex_alloc(unsigned);
	void ex_throw( void*, const static_type_info*, void(*)(void*));
	void* ex_get();
	void ex_rethrow_q() throw();
}

namespace __Cimpl
{
	const char* ex_name();
}

extern "C" void _ex_register( void*, int );

namespace CPPU_CURRENT_NAMESPACE
{

inline char* adjustPointer( char* pIn, typelib_TypeDescription* pType )
{
	switch( pType->nSize )
	{
		case 1: return pIn + 3;
		case 2: return pIn + 2;
		case 3: return pIn + 1;
			// Huh ? perhaps a char[3] ? Though that would be a pointer
			// well, we have it anyway for symmetry
	}
	return pIn;
}

//##################################################################################################
//#### exceptions ##################################################################################
//##################################################################################################

void cc50_solaris_sparc_raiseException(
    uno_Any * pUnoExc, uno_Mapping * pUno2Cpp );

void cc50_solaris_sparc_fillUnoException(
    void*, const char*,
    uno_Any*, uno_Mapping * pCpp2Uno );

}

