/* $RCSfile: config.h,v $
-- $Revision: 1.3.20.2 $
-- last change: $Author: vg $ $Date: 2005/07/01 12:24:40 $
--
-- SYNOPSIS
--      Configurarion include file.
-- 
-- DESCRIPTION
-- 	There is one of these for each specific machine configuration.
--	It can be used to further tweek the machine specific sources
--	so that they compile.
--
-- AUTHOR
--      Dennis Vadura, dvadura@dmake.wticorp.com
--
-- WWW
--      http://dmake.wticorp.com/
--
-- COPYRIGHT
--      Copyright (c) 1996,1997 by WTI Corp.  All rights reserved.
-- 
--      This program is NOT free software; you can redistribute it and/or
--      modify it under the terms of the Software License Agreement Provided
--      in the file <distribution-root>/readme/license.txt.
--
-- LOG
--      Use cvs log to obtain detailed change logs.
*/
/* Attention! In the UNIX like builds with the ./configure ; make
   procedure a config.h is generated. The autogenerated config.h
   must not be there to compile dmake with MSC and the
   "dmake\make.bat win95-vpp40" command. This file sets (among other
   things) the needed HAS_... and HAVE_... macros.

   Don't forget to update the PACKAGE and VERSION macros!
*/

/* Name and version number of this package */
#define PACKAGE "dmake"
#define VERSION "4.3"

#if defined (_MSC_VER)
# if _MSC_VER < 500
	Force a compile-time blowup.
	Do not define "#define _MSC_VER" for MSC compilers earlier than 5.0.
# endif
#endif

/* define this for configurations that don't have the coreleft function
 * so that the code compiles.  To my knowledge coreleft exists only on
 * Turbo C, but it is needed here since the function is used in many debug
 * macros. */
#define coreleft() 0L

/* MSC Version 4.0 doesn't understand SIGTERM, later versions do. */
/* config.h is included before signal.h therefore test MSC version */
#if _MSC_VER < 500
#   define SIGTERM SIGINT
#endif

/* Fixes unimplemented line buffering for MSC 5.x and 6.0.
 * MSC _IOLBF is the same as _IOFBF
 */
#if defined(MSDOS) && defined (_MSC_VER)
#   undef  _IOLBF
#   define _IOLBF   _IONBF
#endif

/* in alloc.h: size_t is redefined
 * defined in stdio.h which is included by alloc.h
 */
#if defined(MSDOS) && defined (_MSC_VER)
#   define _TYPES_
#endif

/* in sysintf.c: SIGQUIT is used, this is not defined in MSC */
#ifndef SIGQUIT
#   define SIGQUIT SIGTERM
#endif

/* MSC doesn't seem to care about CONST */
#define CONST

/* MSC has sys/types.h and sys/stat.h (this is tested only with MSVC++ 6.0) */
#define HAVE_SYS_TYPES_H 1
#define HAVE_SYS_STAT_H 1

/* These functions are available! (this is tested only with MSVC++ 6.0) */
#define HAVE_GETCWD 1
#define HAVE_UTIME_NULL 1
#define HAVE_TZSET 1

#define HAVE_ERRNO_H 1
#define HAVE_STRERROR 1
#define HAVE_TEMPNAM 1
#define HAVE_FCNTL_H 1

/* These defines are needed for itypes.h! (this is tested only with MSVC++ 6.0) */
#define SIZEOF_INT 4
#define SIZEOF_LONG 4
#define SIZEOF_SHORT 2

#ifndef MSDOS
#   define MSDOS 1
#endif

/* a small problem with pointer to voids on some unix machines needs this */
#define PVOID void *

/* Use my own tempnam for MSC Version less than 6.0 */
#if _MSC_VER < 600
#   define tempnam dtempnam
#endif

