/*************************************************************************
 *
 *  $RCSfile: salsound.hxx,v $
 *
 *  $Revision: 1.1.1.1.296.1 $
 *
 *  last change: $Author: vg $ $Date: 2005/04/29 14:25:35 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SV_SALSOUND_HXX
#define _SV_SALSOUND_HXX

#include <tools/link.hxx>

#ifndef _GEN_HXX
#include <tools/gen.hxx>
#endif


#ifndef _GEN_HXX
#include <tools/gen.hxx>
#endif
#ifndef _SV_SV_H
#include <sv.h>
#endif
#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif
#ifndef _SV_SALSTYPE_HXX
#include <salstype.hxx>
#endif

class SalFrame;
// ------------
// - SalSound -
// ------------

namespace vcl_sal {
	class VSound;
}

class SalSound
{
// public for VSound sub classes
public:
	// the real sound
	::vcl_sal::VSound*		m_pVSound;

    static ULONG                            s_nSoundState;
	
	// for notification
	void*					m_pInst;
	SALSOUNDPROC			m_aPROC;

	// the sound to play
	ByteString				m_aSoundFile;
	// and its display
	SalFrame*				m_pFrame;
	
	// state data
	BOOL					m_bLoop:1;
	BOOL					m_bPlaying:1;
	BOOL					m_bPaused:1;
	
	ULONG					m_nStartTime;
	ULONG					m_nPlayTime;
	
	void changeStatePlay();
	void changeStateStop();
	void changeStatePause();
	void changeStateCont();
	void setError( ULONG );
public:
	
	SalSound();
	~SalSound();
	
	BOOL			Create();	// initalize audio library
	static void		Release();
	static BOOL		IsValid();
	
	BOOL			Init( SalFrame*		pFrame,
						  const String&	rSoundName,
						  ULONG&		rSoundLen );
	BOOL			Init( SalFrame*		pFrame,
						  const BYTE*	pSound,
						  ULONG			nDataLen,	
						  ULONG&		rSoundLen );
	void			Play( ULONG nStartTime, ULONG nPlayTime, BOOL bLoop );
	void			Stop();
	void			Pause();
	void			Continue();

	void			SetNotifyProc( void* pInst, SALSOUNDPROC pProc ); 

	BOOL			IsLoopMode() const { return m_bLoop; }
	BOOL			IsPlaying() const { return m_bPlaying; }
	BOOL			IsPaused() const { return m_bPaused; }
};

#endif // _SV_SALSOUND_HXX
