#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.9.250.4 $
#
#   last change: $Author: vg $ $Date: 2005/06/03 12:44:21 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************
PRJ=..$/..$/..

PRJNAME=vcl
TARGET=salapp
.INCLUDE :  $(PRJ)$/util$/makefile.pmk

# --- Settings -----------------------------------------------------

.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  sv.mk

# --- Files --------------------------------------------------------

.IF "$(GUIBASE)"!="unx"

dummy:
	@echo "Nothing to build for GUIBASE $(GUIBASE)"

.ELSE		# "$(GUIBASE)"!="unx"

.IF "$(remote)"==""
OBJFILES=\
			$(OBJ)$/salmain.obj

SLOFILES=\
			$(SLO)$/i18n_cb.obj			\
			$(SLO)$/i18n_ic.obj			\
			$(SLO)$/i18n_im.obj			\
			$(SLO)$/i18n_xkb.obj		\
			$(SLO)$/i18n_wrp.obj		\
			$(SLO)$/i18n_status.obj		\
			$(SLO)$/i18n_keysym.obj		\
			$(SLO)$/salmain.obj			\
			$(SLO)$/saldata.obj			\
			$(SLO)$/saltimer.obj		\
			$(SLO)$/saldisp.obj			\
			$(SLO)$/salinst.obj			\
			$(SLO)$/salsys.obj			\
			$(SLO)$/soicon.obj			\
			$(SLO)$/sm.obj				\
			$(SLO)$/stacktrace.obj		\
			$(SLO)$/keysymnames.obj		\
			$(SLO)$/wmadaptor.obj

SLOFILES+=\
			$(SLO)$/salsound2.obj		\
			$(SLO)$/osssound.obj		\
			$(SLO)$/devaudiosound.obj		\
			$(SLO)$/audioconvert.obj		\
			$(SLO)$/rptpsound.obj		\
			$(SLO)$/nassound.obj		

.IF "$(ENABLE_PASF)" == "YES"
CFLAGS+=-DUSE_PASF
.IF "$(SYSTEM_PORTAUDIO)" == "YES"
CFLAGS+=-DSYSTEM_PORTAUDIO
.ENDIF
.IF "$(SYSTEM_SNDFILE)" == "YES"
CFLAGS+=-DSYSTEM_SNDFILE
.ENDIF
SLOFILES+=$(SLO)$/pasfsound.obj
.ENDIF

.IF "$(WITH_LIBSN)"=="YES"
CDEFS+=-DHAVE_LIBSN
CFLAGS+=$(LIBSN_CFLAGS)
.ENDIF

.IF "$(SYSTEM_NAS)"=="YES"
CDEFS+=-DSYSTEM_NAS
CFLAGS+=-I$(NAS_INCLUDES)
.ENDIF

.IF "$(USE_XINERAMA)" != "NO"
CDEFS+=-DUSE_XINERAMA
.ENDIF

.IF "$(OS)$(CPU)" == "SOLARISS"
.IF "$(COM)"!="GCC"
SLOFILES+=$(SLO)$/getfpsols.obj
.ENDIF			# "$(COM)"!="GCC"
.ELIF "$(OS)$(CPU)" == "SOLARISI"
SLOFILES+=$(SLO)$/getfpsoli.obj
.ENDIF

.ELSE
SLOFILES=\
			$(SLO)$/salmain.obj
.ENDIF

.IF "$(remote)"!=""
EXCEPTIONSFILES=$(SLO)$/salmain.obj	\
		$(OBJ)$/salmain.obj
.ENDIF

.ENDIF		# "$(GUIBASE)"!="unx"

# --- Targets ------------------------------------------------------

.INCLUDE :  target.mk

.INCLUDE :  $(PRJ)$/util$/target.pmk


$(SLO)$/%.obj: %.s
	CC -c -o $(@:s/.obj/.o/) $< && touch $@

